module Fp08 where
--import Control.Monad.Instances (Начиная с GHC 7.6.1 instances have been moved to the Prelude )
import Data.Functor ( (<$>) )
import Control.Applicative
import Data.Traversable

data Tree a = Leaf a | Branch (Tree a) a (Tree a) 
  deriving Show

instance Functor Tree where
--fmap :: (a -> b) -> Tree a -> Tree b
  fmap g (Leaf x)       = Leaf (g x)
  fmap g (Branch l x r) = Branch (fmap g l) (g x) (fmap g r)
  
testTree = Branch (Leaf 2) 3 (Leaf 4)
{-
*Fp08> let testTree = Branch (Leaf 2) 3 (Leaf 4)
*Fp08> fmap (^2) testTree
Branch (Leaf 4) 9 (Leaf 16)
*Fp08> (^3) <$> testTree
Branch (Leaf 8) 27 (Leaf 64)
-}

{-
class Functor f => Pointed f where
  pure :: a -> f a -- aka singleton, return, unit, point

instance Pointed Maybe where
--pure :: a -> Maybe a
  pure x  = Just x

instance Pointed [] where
--pure :: a -> [a]
  pure x  = [x]

instance Pointed ((->) e) where
--pure :: a -> e -> a
  pure = const

-- не очень-то хорошо, контекст Monoid s => может спасти дело 
instance Pointed ((,) s) where
--pure :: a -> (s, a)
  pure x = (undefined, x)

instance Pointed (Either e) where
--pure :: a -> Either e a
  pure x = Right x

instance Pointed Tree where
--pure :: a -> Tree a
  pure x = Leaf x -- как для деревьев другой структуры, например с Nil?
-}

-- Аппликативный дистрибьютор списка
dist :: Applicative f => [f a] -> f [a]
dist []       = pure []
dist (ax : axs) = (:) <$> ax <*> (dist axs)
{-
*Fp08> dist [Just 3,Just 5]
Just [3,5]
*Fp08> dist [Just 3,Nothing]
Nothing
*Fp08> getZipList $ dist $ map ZipList [[1,2,3],[4,5,6]]
[[1,4],[2,5],[3,6]]
*Fp08>
-}